/**
	$Id: AbstractCustomRequestHandler.java 5446 2010-10-15 11:59:00Z nicklas $

	Copyright (C) 2010 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.clients.jobagent.handlers;

import net.sf.basedb.clients.jobagent.Agent;

/**
	Abstract base class for custom request handler implementations. This 
	class implements the init() and close() methods, leaving the handleCmd()
	method for the actual subclass.

	@author Nicklas
	@since 2.16
	@base.modified $Date: 2010-10-15 13:59:00 +0200 (fre, 15 okt. 2010) $
*/
public abstract class AbstractCustomRequestHandler
	implements CustomRequestHandler
{

	private Agent agent;
	
	protected AbstractCustomRequestHandler()
	{}
	
	/*
		From the CustomRequestHandler interface
		---------------------------------------
	*/
	@Override
	public void init(Agent agent)
	{
		this.agent = agent;
	}
	@Override
	public void close()
	{
		agent = null;
	}
	// -----------------------------------
	
	protected Agent getAgent()
	{
		return agent;
	}
	

}
