/**
	$Id: StopRequestHandler.java 6127 2012-09-14 07:28:35Z nicklas $

	Copyright (C) 2006 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.clients.jobagent.handlers;

import java.net.Socket;

import net.sf.basedb.clients.jobagent.Agent;
import net.sf.basedb.util.jobagent.RequestHandler;

/**
	This is a request handler for the <code>stop</code> command. It shuts down the 
	job agent by calling the {@link Agent#stop()} method.

	@author nicklas
	@version 2.0
	@base.modified $Date: 2012-09-14 09:28:35 +0200 (fre, 14 sep. 2012) $
*/
public class StopRequestHandler
	implements RequestHandler
{

	private final Agent agent;
	
	/**
		Create a new stop request handler.
		@param agent The agent
	*/
	public StopRequestHandler(Agent agent)
	{
		this.agent = agent;
	}
	
	/*
		From the RequestHandler interface
		-------------------------------------------
	*/
	@Override
	public String handleCmd(Socket incoming, String cmd)
	{
		String answer = "OK";
		if ("stop".equals(cmd))
		{
			agent.stop();
		}
		else 
		{
			answer = "FAILED Unhandled command: " + cmd;
		}
		return answer;
	}
	// -------------------------------------------

}
