/**
	$Id: MenuItemBean.java 6652 2014-12-09 11:48:21Z nicklas $

	Copyright (C) Authors contributing to this file.

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.clients.web.extensions.menu;

import net.sf.basedb.clients.web.extensions.DynamicActionAttributeSupport;

/**
	A simple bean-like implementation of the {@link MenuItemAction}
	interface.
	
	@author nicklas
	@version 2.7
	@base.modified $Date: 2014-12-09 12:48:21 +0100 (tis, 09 dec. 2014) $
*/
public class MenuItemBean 
	extends DynamicActionAttributeSupport
	implements MenuItemAction 
{

	private String id;
	
	private String menuId;
	private String submenuId;
	private String icon;
	private String clazz;
	private String style;
	private String title;
	private String tooltip;
	private boolean enabled;
	private boolean visible;
	private MenuType type;

	/**
		Create a new empty menu item action.
	*/
	public MenuItemBean()
	{
		type = MenuType.MENUITEM;
		enabled = true;
		visible = true;
	}
	
	/*
		From the MenuItemAction interface
		--------------------------------
	*/
	@Override
	public String getId()
	{
		return id;
	}
	
	@Override
	public String getClazz() 
	{
		return clazz;
	}
	
	@Override
	public String getIcon() 
	{
		return icon;
	}

	@Override
	public String getMenuId()
	{
		return menuId;
	}

	@Override
	public String getStyle() 
	{
		return style;
	}
	
	@Override
	public String getSubmenuId()
	{
		return submenuId;
	}

	@Override
	public String getTitle()
	{
		return title;
	}

	@Override
	public String getTooltip() 
	{
		return tooltip;
	}

	@Override
	public MenuType getType() 
	{
		return type;
	}

	@Override
	public boolean isEnabled() 
	{
		return enabled;
	}

	@Override
	public boolean isVisible() 
	{
		return visible;
	}
	// ------------------------------------
	public void setId(String id)
	{
		this.id = id;
	}
	
	public void setClazz(String clazz) 
	{
		this.clazz = clazz;
	}
	
	public void setIcon(String icon) 
	{
		this.icon = icon;
	}

	public void setMenuId(String menuId)
	{
		this.menuId = menuId;
	}
	
	public void setStyle(String style) 
	{
		this.style = style;
	}
	
	public void setSubmenuId(String submenuId)
	{
		this.submenuId = submenuId;
	}

	public void setTitle(String title) 
	{
		this.title = title;
	}

	public void setTooltip(String tooltip) 
	{
		this.tooltip = tooltip;
	}

	public void setEnabled(boolean enabled) 
	{
		this.enabled = enabled;
	}
	
	public void setVisible(boolean visible) 
	{
		this.visible = visible;
	}

	public void setType(MenuType type) 
	{
		this.type = type;
	}

}
