/**
	$Id: OverviewPlotAction.java 4908 2009-04-28 12:47:33Z nicklas $

	Copyright (C) 2009 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.clients.web.extensions.plot;

import net.sf.basedb.util.extensions.Action;

/**
	Action for generating overview plots for a bioassay set.

	@author Nicklas
	@version 2.12
	@base.modified $Date: 2009-04-28 14:47:33 +0200 (tis, 28 apr. 2009) $
*/
public interface OverviewPlotAction
	extends Action
{
	/**
		The ID of the overview plots. It must be unique among the
		actions generated by a single extension. This ID is combined with
		the ID of the extension to generate an application-wide unique ID.
	*/
	public String getId();
	
	/**
		The title of the overview plots. This will typically end
		up as the title of tab on the web page.
	*/
	public String getTitle();
	
	/**
		A description of the overview plots. This is typically shown
		as a tooltip for the tab.
	*/
	public String getDescription();
	
	/**
		The plot generates that contains information for each image that
		is generated. Typically, there is one image for each bioassay,
		but it doesn't have to be like that. Null values in the
		array are allowed and are ignored by the renderer.
	*/
	public PlotGenerator[] getPlotGenerators();
	
}
