/**
	$Id: TabBean.java 6653 2014-12-09 11:56:20Z nicklas $

	Copyright (C) 2010 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.clients.web.extensions.tabcontrol;

import net.sf.basedb.clients.web.extensions.DynamicActionAttributeSupport;

/**
	A simple bean-like implementation of the TabAction 
	interface.

	@author Nicklas
	@since 2.17
	@base.modified $Date: 2014-12-09 12:56:20 +0100 (tis, 09 dec. 2014) $
*/
public class TabBean
	extends DynamicActionAttributeSupport
	implements TabAction
{

	private String id;
	private String clazz;
	private String style;
	private String title;
	private String tooltip;
	private String helpId;
	private boolean visible;
	private String content;
	private int tabIndex;

	public TabBean()
	{}
	
	/*
		From the TabAction interface
		----------------------------
	*/
	@Override
	public String getId()
	{
		return id;
	}

	@Override
	public String getClazz()
	{
		return clazz;
	}

	@Override
	public String getStyle()
	{
		return style;
	}

	@Override
	public String getTitle()
	{
		return title;
	}

	@Override
	public String getTooltip()
	{
		return tooltip;
	}

	@Override
	public String getHelpId()
	{
		return helpId;
	}

	@Override
	public boolean isVisible()
	{
		return visible;
	}

	@Override
	public String getContent()
	{
		return content;
	}
	
	@Override
	public int getTabIndex()
	{
		return tabIndex;
	}
	// --------------------------
	public void setId(String id) 
	{
		this.id = id;
	}

	public void setClazz(String clazz) 
	{
		this.clazz = clazz;
	}

	public void setStyle(String style) 
	{
		this.style = style;
	}

	public void setTitle(String title) 
	{
		this.title = title;
	}

	public void setTooltip(String tooltip) 
	{
		this.tooltip = tooltip;
	}

	public void setVisible(boolean visible) 
	{
		this.visible = visible;
	}
	
	public void setHelpId(String helpId)
	{
		this.helpId = helpId;
	}
	
	public void setContent(String content)
	{
		this.content = content;
	}
	
	public void setTabIndex(int tabIndex)
	{
		this.tabIndex = tabIndex;
	}
}
