/**
	$Id: UnsupportedFileFormatException.java 4594 2008-10-21 07:20:40Z nicklas $

	Copyright (C) 2008 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.core;

/**
	Thrown when an import plug-in is forced to use a file that
	is not of the correct format.
	
	@author Nicklas
	@version 2.9
	@base.modified $Date: 2008-10-21 09:20:40 +0200 (tis, 21 okt. 2008) $
*/
public class UnsupportedFileFormatException
	extends InvalidDataException
{
	private static final long serialVersionUID = -6974393471798478411L;

	/**
		Create a new <code>UnsupportedFileFormatException</code> object.
	*/
	public UnsupportedFileFormatException()
	{
		super();
	}

	/**
		Create a new <code>UnsupportedFileFormatException</code> object.
	 	@param cause Throwable object that caused this exception. 
	*/
	public UnsupportedFileFormatException(Throwable cause)
	{
		super(cause);
	}
	
	/**
		Create a new <code>UnsupportedFileFormatException</code> object with the 
		specified <code>message</code>.
	
		@param message The message to throw with the exception
	*/
	public UnsupportedFileFormatException(String message)
	{
		super(message);
	}
	
	/**
		Create a new <code>UnsupportedFileFormatException</code> object with the 
		specified <code>message</code>.
	
		@param message The message to throw with the exception
	 	@param cause Throwable object that caused this exception.
	*/
	public UnsupportedFileFormatException(String message, Throwable cause)
	{
		super(message, cause);
	}

}
