/*
	$Id: AuthenticationException.java 6423 2014-02-25 12:11:25Z nicklas $

	Copyright (C) 2005 Jari Häkkinen, Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.core.authentication;

/**
	This exception can be thrown when an error occurs during the
	authentication.

	@author Nicklas
	@version 2.0
	@base.modified $Date: 2014-02-25 13:11:25 +0100 (tis, 25 feb. 2014) $
*/
public class AuthenticationException
	extends RuntimeException

{
	/**
		
	*/
	private static final long serialVersionUID = 4258462779202665788L;

	/**
		Create a new <code>AuthenticationException</code> object
		@param msg The error message
	*/
	public AuthenticationException(String msg)
	{
		super("Authentication failed. " + msg);
	}

	/**
		Create a new <code>AuthenticationException</code> object
		@param cause Another exception which is the cause of the error
	*/
	public AuthenticationException(Throwable cause)
	{
		super("Authentication failed. " + cause.getMessage(), cause);
	}
	
	/**
		Create a new <code>AuthenticationException</code> object
		@param msg The error message
		@since 3.0
	*/
	public AuthenticationException(String msg, Throwable cause)
	{
		super("Authentication failed. " + msg, cause);
	}

}

