/*
	$Id: InvalidPasswordException.java 4889 2009-04-06 12:52:39Z nicklas $

	Copyright (C) 2005 Jari Häkkinen, Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.core.authentication;

/**
	This exception can be thrown when the password is invalid.

	@author Nicklas
	@version 2.0
	@base.modified $Date: 2009-04-06 14:52:39 +0200 (mån, 06 apr. 2009) $
*/
public class InvalidPasswordException
	extends AuthenticationException

{
	/**
		
	*/
	private static final long serialVersionUID = 6007471910116426466L;

	/**
		Create a new <code>InvalidPasswordException</code> object
		@param login The login name for which the password is invalid
	*/
	public InvalidPasswordException(String login)
	{
		super("Invalid password for login: " + login);
	}
	
	/**
		Create a new <code>InvalidPasswordException</code> object
		@param login The login name for which the password is invalid
		@param msg An error message with more information
	*/
	public InvalidPasswordException(String login, String msg)
	{
		super("Invalid password for login: "+login+". The error message was: "+msg);
	}

}


