/*
	$Id: UserProjects.java 6870 2015-04-16 11:47:41Z nicklas $

	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.core.data.keyring;
import java.io.Serializable;

/**
	Class for mapping the <code>UserProjects</code> table.
	@author Nicklas
	@version 2.0
	@base.modified $Date: 2015-04-16 13:47:41 +0200 (tors, 16 apr. 2015) $
*/
public final class UserProjects
	extends ProjectPermission
	implements Serializable
{

	/**
		
	*/
	private static final long serialVersionUID = 1268159949109572997L;
	private int userId;
	
	/**
		Create a new <code>UserProjects</code> object.
	*/
	public UserProjects()
	{
		super();
	}

	/**
		Get the id of the user.
	*/
	public int getUserId()
	{
		return userId;
	}
	/**
		Set the id of the user.
	*/
	public void setUserId(int userId)
	{
		this.userId = userId;
	}

	/**
		Check if this object is equal to another <code>UserProjects</code>
		object. They are considered to be the same if the user id and the
		project id are the same. The permission may be different.
	*/
	@Override
	public boolean equals(Object o)
	{
		if ((o == null) || (getClass() != o.getClass())) return false;
		UserProjects up = (UserProjects)o;
		return (up.userId == this.userId) && (up.projectId == this.projectId);
	}
	
	/**
		Calculate the hash code for the object.
	*/
	@Override
	public int hashCode()
	{
		return 31*projectId + 17*userId;
	}
}
