/*
	$Id: SqlQuery.java 5897 2011-12-02 11:09:46Z nicklas $

	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.core.query;

import net.sf.basedb.core.DbControl;
import net.sf.basedb.core.DynamicResultIterator;

/**
	This is a query that is using SQL as the query language. All
	implementors of this interface must return {@link QueryType#SQL}
	from the {@link Query#getQueryType()} method.

	@author Nicklas
	@version 2.0
	@base.modified $Date: 2011-12-02 12:09:46 +0100 (fre, 02 dec. 2011) $
*/
public interface SqlQuery
	extends Query
{
	public DynamicResultIterator iterate(DbControl dc);
}
