/**
	$Id: ListUtil.java 5831 2011-10-27 07:16:20Z nicklas $

	Copyright (C) 2011 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.util;

import java.util.Collection;

/**

	@author Nicklas
	@since 3.0
	@base.modified $Date: 2011-10-27 09:16:20 +0200 (tors, 27 okt. 2011) $
*/
public class ListUtil
{

	/**
		Find the first entry in the master collection that is also present in the
		check collection. If there is no such entry, the notFound value is returned.
		@param master The master collection
		@param check The collection to check
		@param notFound The value to return if there are no common elements 
			(including the case were one collection is null or empty)
	*/
	public static <T> T findFirstCommon(Collection<T> master, Collection<T> check, T notFound)
	{
		if (master == null || check == null || master.isEmpty() || check.isEmpty())
		{
			return notFound;
		}
		// Now we know that both collections have at least one element
		for (T t : master)
		{
			if (check.contains(t)) return t;
		}
		return notFound;
	}
	
}
