/**
	$Id: Accept.java 5623 2011-05-06 12:09:13Z nicklas $

	Copyright (C) 2011 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.util.fileset;

/**
	Return result from the {@link ValidationAction#acceptFile(net.sf.basedb.core.FileSetMember)}
	method.

	@author Nicklas
	@since 3.0
	@base.modified $Date: 2011-05-06 14:09:13 +0200 (fre, 06 maj 2011) $
*/
public enum Accept
{
	/**
		The file is handled by the validator and should be validated immediately.
	*/
	VALIDATE_IMMEDIATELY,
	
	/**
		The file is handled by the validator but should not be validated until
		all files in the file set has been asked for acception.
	*/
	VALIDATE_LATER
}
