/**
	$Id: Severity.java 6127 2012-09-14 07:28:35Z nicklas $

	Copyright (C) 2006 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.util.overview;

/**
	Severity levels for a validation rule.

	@author Nicklas
	@version 2.2
	@base.modified $Date: 2012-09-14 09:28:35 +0200 (fre, 14 sep. 2012) $
*/
public enum Severity
{
	/**
		The rule is ignored.
	*/
	IGNORE("Ignore"), 

	/**
		The rule generate warnings.
	*/
	WARNING("Warning"), 

	/**
		The rule generate errors.
	*/
	ERROR("Error");
	
	private final String displayValue;
	private Severity(String displayValue)
	{
		this.displayValue = displayValue;
	}
	
	@Override
	public String toString()
	{
		return displayValue;
	}
}
