/**
	$Id: AnnotationNameGenerator.java 6037 2012-03-29 09:50:36Z nicklas $

	Copyright (C) 2009 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.util.overview.node;

import net.sf.basedb.core.Annotation;
import net.sf.basedb.util.overview.Node;

/**
	Since an Annotation isn't Nameable we construct the name
	from the name of the annotation type, or from the value
	type if we are not allowed to access the annotation type.

	@author Nicklas
	@version 2.10
	@base.modified $Date: 2012-03-29 11:50:36 +0200 (tors, 29 mars 2012) $
*/
public class AnnotationNameGenerator
	implements NodeNameGenerator<Annotation>
{
	public AnnotationNameGenerator()
	{}

	/*
		From the NodeNameGenerator interface
		------------------------------------
	*/
	@Override
	public String getNodeName(Annotation item, Node parentNode)
	{
		return "annotation." + item.getId();
	}

	@Override
	public String getNodeTitle(Annotation item, Node parentNode)
	{
		return item.getAnnotationType().getName();
	}
	
	@Override
	public String getDeniedNodeName(Node parentNode)
	{
		return "annotation";
	}

	@Override
	public String getDeniedNodeTitle(Node parentNode)
	{
		return "Annotation: denied";
	}

	@Override
	public String getMissingNodeName(Node parentNode)
	{
		return "annotation";
	}

	@Override
	public String getMissingNodeTitle(Node parentNode)
	{
		return "Annotation: missing";
	}
	// --------------------------------------
}