/**
	$Id: WrappedConfigureByExample.java 4515 2008-09-11 20:08:14Z jari $

	Copyright (C) 2006 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.util.parser;

import java.io.IOException;
import java.io.InputStream;

import net.sf.basedb.core.plugin.Plugin;

/**
 	This is an extension to the {@link ConfigureByExample} interface
 	that allows a plug-in to wrap an input stream with another stream.
 	This is useful if the file data is compressed, for example, with gzip.

	@author nicklas
	@version 2.6
	@base.modified $Date: 2008-09-11 22:08:14 +0200 (tors, 11 sep. 2008) $
*/
public interface WrappedConfigureByExample
	extends Plugin
{

	/**
		Wrap an input stream within another stream, for example, a gzip input stream.
		@param in The input stream to wrap
		@return The same or a different input stream
		@throws IOException If there is an error
	*/
	public InputStream wrapInputStream(InputStream in)
		throws IOException;
	
}
