<%-- $Id: edit_annotationtype.jsp 7616 2019-03-04 06:44:18Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.AnnotationType"
	import="net.sf.basedb.core.AnnotationTypeCategory"
	import="net.sf.basedb.core.Quantity"
	import="net.sf.basedb.core.Unit"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Metadata"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.formatter.FormatterSettings"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.clients.web.extensions.tabcontrol.TabAction"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="net.sf.basedb.util.json.NameableConverter"
	import="net.sf.basedb.util.json.JsonUtil"
	import="net.sf.basedb.util.json.JsonConverter"
	import="java.util.Date"
	import="java.util.Set"
	import="java.util.List"
	import="java.util.Collections"
	import="org.json.simple.JSONObject"
	import="org.json.simple.JSONArray"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%
final Item itemType = Item.ANNOTATIONTYPE;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	AnnotationType annotationType = null;
	ItemQuery<AnnotationTypeCategory> categoryQuery = null;
	ItemQuery<Unit> unitQuery = null;
	ItemQuery<Unit> usableUnitsQuery = null;
	Set<Item> enabledForItems = null;
	Type valueType = null;
	boolean readCurrentQuantity = true;
	int currentQuantityId = 0;
	boolean readCurrentUnit = true;
	int currentUnitId = 0;
	long numProjectSpecificAnnotations = 0;
	
	if (itemId == 0)
	{
		title = "Create annotation type";
		valueType = Type.valueOf(request.getParameter("value_type"));
		if (valueType.isNumerical()) unitQuery = Unit.getQuery();	
		cc.removeObject("item");
		int itemCode = Values.getInt(cc.getPropertyValue("@itemTypes"), -1);
		if (itemCode > 0) 
		{
			enabledForItems = Collections.singleton(Item.fromValue(itemCode));
		}
		else
		{
			enabledForItems = Collections.emptySet();
		}
	}
	else
	{
		annotationType = AnnotationType.getById(dc, itemId);
		annotationType.checkPermission(Permission.WRITE);
		valueType = annotationType.getValueType();
		enabledForItems = annotationType.getEnabledItems();
		numProjectSpecificAnnotations = annotationType.countProjectSpecificAnnotations();
		
		cc.setObject("item", annotationType);
		title = "Edit annotation type -- " + HTML.encodeTags(annotationType.getName());
		categoryQuery = annotationType.getCategories();
		categoryQuery.include(Include.ALL);
		categoryQuery.order(Orders.asc(Hql.property("name")));
		
		usableUnitsQuery = annotationType.getUsableUnits();
		usableUnitsQuery.include(Include.ALL);
		usableUnitsQuery.order(Orders.asc(Hql.property("referenceFactor")));
		usableUnitsQuery.order(Orders.asc(Hql.property("name")));
		
		try
		{
			if (annotationType.getValueType().isNumerical())
			{
				Quantity quantity = annotationType.getQuantity();
				if (quantity != null) 
				{
					currentQuantityId = quantity.getId();
					unitQuery = quantity.getUnits();
				}
				else
				{
					unitQuery = Unit.getQuery();
				}
				Unit unit = annotationType.getDefaultUnit();
				if (unit != null) currentUnitId = unit.getId();
			}
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentQuantity = false;
			readCurrentUnit = false;
		}
	}

	JSONArray jsonQuantities = new JSONArray();
	if (unitQuery != null)
	{
		unitQuery.include(Include.ALL);
		unitQuery.order(Orders.asc(Hql.property("quantity.name")));
		unitQuery.order(Orders.asc(Hql.property("referenceFactor")));
		unitQuery.order(Orders.asc(Hql.property("name")));

		Quantity prevQuantity = null;
		JSONArray jsonUnits = null;
		for (Unit unit : unitQuery.list(dc))
		{
			Quantity quantity = unit.getQuantity();
			if (!quantity.equals(prevQuantity))
			{
				prevQuantity = quantity;
				JSONObject jsonQuantity = new JSONObject();
				jsonUnits = new JSONArray();
				jsonQuantity.put("id", quantity.getId());
				jsonQuantity.put("name", quantity.getName());
				jsonQuantity.put("units", jsonUnits);

				jsonQuantities.add(jsonQuantity);
			}
			
			JSONObject jsonUnit = new JSONObject();
			jsonUnit.put("id", unit.getId());
			jsonUnit.put("name", unit.getName());
			jsonUnit.put("symbol", unit.getDisplaySymbol());
			jsonUnits.add(jsonUnit);
		}
	}
	
	JSONObject jsonUsableUnits = new JSONObject();
	jsonUsableUnits.put("itemType", "UNIT");
	if (usableUnitsQuery != null)
	{
		jsonUsableUnits.put("items", JsonUtil.toArray(usableUnitsQuery.iterate(dc), new NameableConverter<Unit>()
		{
			protected void setMore(JSONObject json, Unit unit)
			{
				json.put("name", unit.getName() + " [ " + unit.getDisplaySymbol() + " ]");
			}
		}));
	}
	
	JSONObject jsonCategories = new JSONObject();
	jsonCategories.put("itemType", "ANNOTATIONTYPECATEGORY");
	if (categoryQuery != null)
	{
		jsonCategories.put("items", JsonUtil.toArray(categoryQuery.iterate(dc), new NameableConverter<AnnotationTypeCategory>()));
	}
	
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	String dateFormat = FormatterSettings.getDateFormat(sc);
	String jsDateFormat = HTML.javaScriptEncode(dateFormat);
	String htmlDateFormat = HTML.encodeTags(dateFormat);
	
	Formatter<Date> dateTimeFormatter = FormatterFactory.getDateTimeFormatter(sc);
	String dateTimeFormat = FormatterSettings.getDateTimeFormat(sc);
	String jsDateTimeFormat = HTML.javaScriptEncode(dateTimeFormat);
	String htmlDateTimeFormat = HTML.encodeTags(dateTimeFormat);
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), annotationType);
	ExtensionsInvoker<TabAction> invoker = EditUtil.useEditExtensions(jspContext);
	%>
	<base:page type="popup" title="<%=title%>" id="edit-page">
	<base:head scripts="tabcontrol-2.js,linkitems-2.js,~annotationtypes.js" styles="tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
	</base:head>
	<base:body>
		<h1><%=title%> <base:help tabcontrol="settings" /></h1>
		
		<div id="page-data" class="datacontainer"
			data-current-quantity="<%=currentQuantityId%>"
			data-current-unit="<%=currentUnitId%>"
			data-units="<%=HTML.encodeTags(jsonQuantities.toJSONString())%>"
			></div>
		
		<form action="index.jsp?ID=<%=ID%>" method="post" name="annotationType">
		<input type="hidden" name="cmd" value="UpdateItem">
		<input type="hidden" name="value_type" value="<%=valueType.name()%>">

		<t:tabcontrol id="settings" 
			subclass="content dialogtabcontrol"
			position="bottom" remember="<%=annotationType != null%>"
			extensions="<%=invoker%>">
		<t:tab id="info" title="Annotation type" helpid="annotationtype.edit">
			<table class="fullform input100">
			<tr>
				<th>Value type</th>
				<td><%=valueType%></td>
				<td></td>
			</tr>
			<tr>
				<th>Name</th>
				<td><input class="text required auto-init" data-auto-init="<%=annotationType == null ? "focus-select" : "focus" %>"
					type="text" name="name" 
					value="<%=HTML.encodeTags(annotationType == null ? 
					Values.getString(cc.getPropertyValue("name"), "New "+valueType+" annotation type") : annotationType.getName())%>" 
					maxlength="<%=AnnotationType.MAX_NAME_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr>
				<th>External ID</th>
				<td><input class="text" type="text" name="external_id" 
					value="<%=HTML.encodeTags(annotationType == null ? 
					Values.getString(cc.getPropertyValue("externalId"), "") : annotationType.getExternalId())%>" 
					maxlength="<%=AnnotationType.MAX_EXTERNAL_ID_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr>
				<th>Multiplicity</th>
				<td><input class="text auto-init" type="text" name="multiplicity" id="multiplicity"
					data-auto-init="integer-only"
					value="<%=annotationType == null ? Values.getString(cc.getPropertyValue("multiplicity"), "1") : 
					Integer.toString(annotationType.getMultiplicity())%>" style="width: 15em;"
					maxlength="10">
					0 or empty = unlimited
				</td>
				<td></td>
			</tr>
			<tr class="<%=valueType == Type.TEXT ? "big" : ""%>">
				<th>Default value</th>
				<td>
					<%
					String defaultValue = annotationType == null ? cc.getPropertyValue("defaultValue") : annotationType.getDefaultValue();
					boolean hasZoom = false;
					if (valueType == Type.INT || valueType == Type.LONG)
					{
						%>
						<input class="text auto-init" type="text" name="defaultValue" id="defaultValue"
							data-auto-init="integer-only"
							value="<%=HTML.encodeTags(defaultValue)%>" style="width: 15em;"
							maxlength="20">
						<%
					}
					else if (valueType == Type.FLOAT || valueType == Type.DOUBLE)
					{
						%>
						<input class="text auto-init" type="text" name="defaultValue" id="defaultValue"
							data-auto-init="number-only"
							value="<%=HTML.encodeTags(defaultValue)%>" style="width: 15em;"
							maxlength="20">
						<%
					}
					else if (valueType == Type.BOOLEAN)
					{
						boolean booleanDefaultValue = Values.getBoolean(defaultValue);
						%>
						<input type="radio" name="defaultValue" id="defaultTrue" value="true" 
							<%=booleanDefaultValue ? "checked" : ""%>
						><label for="defaultTrue">true</label>
						<input type="radio" name="defaultValue" id="defaultFalse" value="false" 
							<%=booleanDefaultValue ? "" : "checked"%>
						><label for="defaultFalse">false</label>
						<%
					}
					else if (valueType == Type.DATE)
					{
						%>
						<table>
						<tr>
						<td>
							<input class="text" type="text" name="defaultValue" id="defaultValue"
								value="<%=HTML.encodeTags(defaultValue)%>" style="width: 15em;"
								maxlength="20" title="Enter date in format: <%=htmlDateFormat%>">
						</td>
						<td>
							<base:calendar textarea="defaultValue" title="Default value" />
						</td>
						</tr>
						</table>
						<%
					}
					else if (valueType == Type.TIMESTAMP)
					{
						%>
						<table>
						<tr>
						<td>
							<input class="text" type="text" name="defaultValue" id="defaultValue"
								value="<%=HTML.encodeTags(defaultValue)%>" style="width: 15em;"
								maxlength="30" title="Enter date in format: <%=htmlDateTimeFormat%>">
						</td>
						<td>
							<base:calendar textarea="defaultValue" title="Default value" 
								data-use-time="1" tooltip="Select a date and time from a calendar" />
						</td>
						</tr>
						</table>
						<%
					}
					else if (valueType == Type.STRING)
					{
						%>
						<input class="text" type="text" name="defaultValue" id="defaultValue"
							value="<%=HTML.encodeTags(defaultValue)%>" 
							maxlength="<%=AnnotationType.MAX_DEFAULT_VALUE_LENGTH%>">
					<%
					}
					else if (valueType == Type.TEXT)
					{
						hasZoom = true;
						%>
						<textarea class="text" rows="4" name="defaultValue" id="defaultValue"
							><%=HTML.encodeTags(defaultValue)%></textarea>
						<%
					}
					%>
				</td>
				<td>
				<%
				if (hasZoom)
				{
					%>
					<base:zoom textarea="defaultValue" title="Default value" />
					<%
				}
				%>
				</td>
			</tr>
			<%
			if (valueType == Type.STRING || valueType == Type.INT || valueType == Type.LONG)
			{
				%>
				<tr>
					<th><label for="identifier">Is identifier</label></th>
					<td><input type="checkbox" name="identifier" id="identifier" value="1" 
						<%=(annotationType != null && annotationType.isIdentifier()) || 
							(annotationType == null && Values.getBoolean(cc.getPropertyValue("identifier"))) ? "checked" : ""%>
						>
					</td>
					<td></td>
				</tr>
				<%
			}
			%>
			<tr>
				<th><label for="required_for_miame">Required for MIAME</label></th>
				<td><input type="checkbox" name="required_for_miame" id="required_for_miame" value="1" 
					<%=(annotationType != null && annotationType.isRequiredForMiame()) || 
						(annotationType == null && Values.getBoolean(cc.getPropertyValue("requiredForMiame"))) ? "checked" : ""%>
					>
				</td>
				<td></td>
			</tr>
			<tr>
				<th><label for="is_protocol_parameter">Protocol parameter</label></th>
				<td><input type="checkbox" name="is_protocol_parameter" id="is_protocol_parameter" value="1" 
					<%=(annotationType != null && annotationType.isProtocolParameter()) || 
						(annotationType == null && Values.getBoolean(cc.getPropertyValue("protocolParameter"))) ? "checked" : ""%>
					>
				</td>
				<td></td>
			</tr>
			<tr>
				<th><label for="disable_log">Disable history log</label></th>
				<td><input type="checkbox" name="disable_log" id="disable_log" value="1" 
					<%=(annotationType != null && annotationType.getDisableLogOfValues()) || 
						(annotationType == null && Values.getBoolean(cc.getPropertyValue("disableLogOfValues"))) ? "checked" : ""%>
					>
				</td>
				<td></td>
			</tr>
			<tr>
				<th><label for="disable_inheritance">Disable inheritance</label></th>
				<td><input type="checkbox" name="disable_inheritance" id="disable_inheritance" value="1" 
					<%=(annotationType != null && annotationType.getDisableInheritance()) || 
						(annotationType == null && Values.getBoolean(cc.getPropertyValue("disableInheritance"))) ? "checked" : ""%>
					>
				</td>
				<td></td>
			</tr>
			<tr>
				<th><label for="project_annotations">Project annotations</label></th>
				<td><input type="checkbox" name="project_annotations" id="project_annotations" value="1" 
					<%=(annotationType != null && annotationType.getProjectAnnotations()) || 
						(annotationType == null && Values.getBoolean(cc.getPropertyValue("projectAnnotations"))) ? "checked" : ""%>
						<%=numProjectSpecificAnnotations > 0 ? "disabled" : "" %>
					>
					<%
					if (numProjectSpecificAnnotations > 0)
					{
						%>
						There are <%=numProjectSpecificAnnotations %> existing project-specific annotations.
						<%
					}
					%>
				</td>
				<td></td>
			</tr>
			<tr class="dynamic">
				<th>Description</th>
				<td>
					<textarea class="text" rows="4" name="description" id="description"
						><%=HTML.encodeTags(annotationType == null ? cc.getPropertyValue("description") : annotationType.getDescription())%></textarea>
				</td>
				<td style="width: 20px;">
					<base:zoom textarea="description" title="Description" />
				</td>
			</tr>
			</table>
		</t:tab>
		
		<t:tab id="options" title="Options" helpid="annotationtype.edit.options">
			<%
			if (valueType == Type.INT || valueType == Type.LONG)
			{
				Long minValue = annotationType == null ? null : annotationType.getMinValueLong();
				Long maxValue = annotationType == null ? null : annotationType.getMaxValueLong();
				boolean isEnumeration = annotationType == null ? 
					Values.getBoolean(cc.getPropertyValue("enumeration")) : annotationType.isEnumeration();
				boolean displayAsList = annotationType == null ? false : annotationType.getDisplayAsList();
				%>
				<table class="fullform input100">
				<tr>
					<th>Interface</th>
					<td>
						<input type="radio" name="interface" id="interfaceBox" value="box"
							<%=!isEnumeration ? "checked" : ""%>
						><label for="interfaceBox">text box</label>
						<input type="radio" name="interface" id="interfaceList" value="list" 
							<%=isEnumeration && displayAsList ? "checked" : ""%>
						><label for="interfaceList">selection list</label>
						<input type="radio" name="interface" id="interfaceButtons" value="buttons" 
							<%=isEnumeration && !displayAsList ? "checked" : ""%>
						><label for="interfaceButtons">radiobuttons/checkboxes</label>
					</td>
					<td></td>
				</tr>
				<tr>
					<th>Min value</th>
					<td>
						<input class="text auto-init" type="text" name="minValue" 
							data-auto-init="integer-only"
							value="<%=minValue == null ? "" : minValue.toString()%>" style="width: 15em;"
							maxlength="20">
						empty = no limit
					</td>
					<td></td>
				</tr>
				<tr>
					<th>Max value</th>
					<td>
						<input class="text auto-init" type="text" name="maxValue" 
							data-auto-init="integer-only"
							value="<%=maxValue == null ? "" : maxValue.toString()%>" style="width: 15em;"
							maxlength="20">
						empty = no limit
					</td>
					<td></td>
				</tr>
				<tr>
					<th>Input box width</th>
					<td>
						<input class="text auto-init" type="text" name="width" style="width: 15em;"
							data-auto-init="integer-only"
							value="<%=annotationType == null ? "" : annotationType.getWidth()%>" 
							maxlength="10">
					</td>
					<td></td>
				</tr>
				<tr class="dynamic">
					<th>Values</th>
					<td>
						<%
						String values = annotationType == null ? "" : Values.getString(annotationType.getValues(), "\n", true);
						%>
						<textarea class="text auto-init" rows="10" name="values" id="values"
							data-auto-init="integer-only"><%=HTML.encodeTags(values)%></textarea><br>
					</td>
					<td style="width: 20px;">
						<base:zoom textarea="values" title="Values" />
					</td>
				</tr>
				<tr>
					<th class="subprompt"></th>
					<td>One enumeration value per line</td>
					<td></td>
				</tr>
				</table>
				<%
			}
			else if (valueType == Type.FLOAT || valueType == Type.DOUBLE)
			{
				Double minValue = annotationType == null ? null : annotationType.getMinValueDouble();
				Double maxValue = annotationType == null ? null : annotationType.getMaxValueDouble();
				boolean isEnumeration = annotationType == null ? 
					Values.getBoolean(cc.getPropertyValue("enumeration")) : annotationType.isEnumeration();
				boolean displayAsList = annotationType == null ? false : annotationType.getDisplayAsList();
				%>
				<table class="fullform input100">
				<tr>
					<th>Interface</th>
					<td>
						<input type="radio" name="interface" id="interfaceBox" value="box"
							<%=!isEnumeration ? "checked" : ""%>
						><label for="interfaceBox">text box</label>
						<input type="radio" name="interface" id="interfaceList" value="list" 
							<%=isEnumeration && displayAsList ? "checked" : ""%>
						><label for="interfaceList">selection list</label>
						<input type="radio" name="interface" id="interfaceButtons" value="buttons" 
							<%=isEnumeration && !displayAsList ? "checked" : ""%>
						><label for="interfaceButtons">radiobuttons/checkboxes</label>
					</td>
					<td></td>
				</tr>
				<tr>
					<th>Min value</th>
					<td>
						<input class="text auto-init" type="text" name="minValue" 
							data-auto-init="number-only"
							value="<%=minValue == null ? "" : minValue.toString()%>" style="width: 15em;"
							maxlength="20">
						empty = no limit
					</td>
					<td></td>
				</tr>
				<tr>
					<th>Max value</th>
					<td>
						<input class="text auto-init" type="text" name="maxValue" 
							data-auto-init="number-only"
							value="<%=maxValue == null ? "" : maxValue.toString()%>" style="width: 15em;"
							maxlength="20">
						empty = no limit
					</td>
					<td></td>
				</tr>
				<tr>
					<th>Input box width</th>
					<td>
						<input class="text auto-init" type="text" name="width" 
							data-auto-init="integer-only"
							value="<%=annotationType == null ? "" : annotationType.getWidth()%>" style="width: 15em;"
							maxlength="10">
					</td>
					<td></td>
				</tr>
				<tr class="dynamic">
					<th>Values</th>
					<td>
						<%
						String values = annotationType == null ? "" : Values.getString(annotationType.getValues(), "\n", true);
						%>
						<textarea class="text auto-init" rows="10" name="values" id="values"
							data-auto-init="integer-only"><%=HTML.encodeTags(values)%></textarea>
					</td>
					<td style="width: 20px;">
						<base:zoom textarea="values" title="Values" />
					</td>
				</tr>
				<tr>
					<th class="subprompt"></th>
					<td>One enumeration value per line</td>
					<td></td>
				</tr>
				</table>
				<%
			}
			else if (valueType == Type.BOOLEAN)
			{
				%>
				<div style="border: 1px solid transparent;">
				<div class="messagecontainer help">
				No options for this type.
				</div>
				</div>
				<%
			}
			else if (valueType == Type.DATE)
			{
				boolean isEnumeration = annotationType == null ? 
					Values.getBoolean(cc.getPropertyValue("enumeration")) : annotationType.isEnumeration();
				boolean displayAsList = annotationType == null ? false : annotationType.getDisplayAsList();
				%>
				<table class="fullform input100">
				<tr>
					<th>Interface</th>
					<td>
						<input type="radio" name="interface" id="interfaceBox" value="box"
							<%=!isEnumeration ? "checked" : ""%>
						><label for="interfaceBox">text box</label>
						<input type="radio" name="interface" id="interfaceList" value="list" 
							<%=isEnumeration && displayAsList ? "checked" : ""%>
						><label for="interfaceList">selection list</label>
						<input type="radio" name="interface" id="interfaceButtons" value="buttons" 
							<%=isEnumeration && !displayAsList ? "checked" : ""%>
						><label for="interfaceButtons">radiobuttons/checkboxes</label>
					</td>
					<td></td>
				</tr>
				<tr>
					<th>Input box width</th>
					<td>
						<input class="text auto-init" type="text" name="width" 
							data-auto-init="integer-only"
							value="<%=annotationType == null ? "" : annotationType.getWidth()%>" style="width: 15em;"
							maxlength="10">
					</td>
					<td></td>
				</tr>
				<tr class="dynamic">
					<th>Values</th>
					<td>
						<%
						String values = annotationType == null ? "" : 
							Values.getString(annotationType.getValues(), "\n", true, dateFormatter);
						%>
						<textarea class="text" rows="10" name="values" id="values"
							><%=HTML.encodeTags(values)%></textarea>
					</td>
					<td style="width: 20px;">
						<base:zoom textarea="values" title="Values" />
					</td>
				</tr>
				<tr>
					<th class="subprompt"></th>
					<td>One date value (<%=htmlDateFormat%>) per line</td>
					<td></td>
				</tr>
				</table>
				<%
			}
			else if (valueType == Type.TIMESTAMP)
			{
				%>
				<table class="fullform input100">
				<tr>
					<th>Input box width</th>
					<td>
						<input class="text auto-init" type="text" name="width" 
							data-auto-init="integer-only"
							value="<%=annotationType == null ? "" : annotationType.getWidth()%>" style="width: 15em;"
							maxlength="10">
					</td>
				</tr>
				<tr class="dynamic">
					<th class="subprompt"></th>
					<td></td>
				</tr>
				</table>
				<%
			}
			else if (valueType == Type.STRING)
			{
				Integer maxLength = annotationType == null ? null : annotationType.getMaxLength();
				boolean isEnumeration = annotationType == null ? 
					Values.getBoolean(cc.getPropertyValue("enumeration")) : annotationType.isEnumeration();
				boolean displayAsList = annotationType == null ? false : annotationType.getDisplayAsList();
				%>
				<table class="fullform input100">
				<tr>
					<th>Interface</th>
					<td>
						<input type="radio" name="interface" id="interfaceBox" value="box"
							<%=!isEnumeration ? "checked" : ""%>
						><label for="interfaceBox">text box</label>
						<input type="radio" name="interface" id="interfaceList" value="list" 
							<%=isEnumeration && displayAsList ? "checked" : ""%>
						><label for="interfaceList">selection list</label>
						<input type="radio" name="interface" id="interfaceButtons" value="buttons" 
							<%=isEnumeration && !displayAsList ? "checked" : ""%>
						><label for="interfaceButtons">radiobuttons/checkboxes</label>
					</td>
					<td></td>
				</tr>
				<tr>
					<th>Max length</th>
					<td>
						<input class="text auto-init" type="text" name="maxLength"
							data-auto-init="integer-only" 
							value="<%=maxLength == null ? "" : maxLength.toString()%>" style="width: 5em;"
							maxlength="3"> (1-255)
					</td>
					<td></td>
				</tr>
				<tr>
					<th>Input box width</th>
					<td>
						<input class="text auto-init" type="text" name="width" 
							data-auto-init="integer-only" 
							value="<%=annotationType == null ? "" : annotationType.getWidth()%>" style="width: 15em;"
							maxlength="10">
					</td>
					<td></td>
				</tr>
				<tr class="dynamic">
					<th>Values</th>
					<td>
						<%
						String values = annotationType == null ? "" : Values.getString(annotationType.getValues(), "\n", true);
						%>
						<textarea class="text" rows="10" name="values" id="values"><%=HTML.encodeTags(values)%></textarea>
					</td>
					<td style="width: 20px;">
						<base:zoom textarea="values" title="Values" />
					</td>
				</tr>
				<tr>
					<th class="subprompt"></th>
					<td>One enumeration value per line</td>
					<td></td>
				</tr>
				</table>
				<%
			}
			else if (valueType == Type.TEXT)
			{
				%>
				<table class="fullform input100">
				<tr>
					<th>Input box width</th>
					<td>
						<input class="text auto-init" type="text" name="width" 
							data-auto-init="integer-only" 
							value="<%=annotationType == null ? "" : annotationType.getWidth()%>" style="width: 15em;"
							maxlength="10">
					</td>
				</tr>
				<tr>
					<th>Input box height</th>
					<td>
						<input class="text auto-init" type="text" name="width" 
							data-auto-init="integer-only" 
							value="<%=annotationType == null ? "" : annotationType.getHeight()%>" style="width: 15em;"
							maxlength="10">
					</td>
				</tr>
				<tr class="dynamic">
					<th></th>
					<td></td>
				</tr>
				</table>
				<%
			}
			%>
		</t:tab>
		
		<t:tab id="items" title="Item types" helpid="annotationtype.edit.items">
			<div style="padding: 2px;">
			<table style="width: 100%;">
			<tr>
				<td style="width: 50%;">
					<b>Enabled for</b><br>
					<select name="enabled" id="enabled" multiple size="14" style="width: calc(100% - 10px);"
						data-to-id="disabled" data-is-sorted="1">
					<%
					for (Item item : enabledForItems)
					{
						%>
						<option value="<%=item.name()%>"><%=item.toString()%>
						<%
					}
					%>
					</select>
				</td>
				<td style="width: 20px; padding: 2px;">
					<base:buttongroup vertical="true">
						<base:button
							id="btnMoveLeft"
							data-from-id="disabled"
							data-to-id="enabled"
							image="move_left.png" 
							tooltip="Enable the annotation type for the selected item(s)" 
							subclass="square"
						/>
						<base:button 
							id="btnMoveRight"
							data-from-id="enabled"
							data-to-id="disabled"
							image="move_right.png" 
							subclass="square"
							tooltip="Disable the annotation type for the selected item(s)" 
						/>
					</base:buttongroup>
				</td>
				<td style="width: 50%;">
					<b>Disabled for</b><br>
					<select name="disabled" id="disabled" multiple size="14" style="width: calc(100% - 10px);"
						data-to-id="enabled" data-is-sorted="1">
						<%
						for (Item item : Metadata.getAnnotatableItems())
						{
							if (!enabledForItems.contains(item))
							{
								%>
								<option value="<%=item.name()%>"><%=item.toString()%>
								<%
							}
						}
						%>
					</select>
				</td>
			</tr>
			</table>
			</div>
		</t:tab>
		
		<t:tab id="units" title="Units" 
			visible="<%=valueType.isNumerical()%>" helpid="annotationtype.edit.units">
		
			<table class="fullform input100">
			<tr>
				<th>Quantity</th>
				<td>
					<select name="quantity_id" id="quantity_id"
						<%=!readCurrentQuantity || (annotationType != null && currentQuantityId != 0) ? 
								"disabled readonly class=\"disabled\"" : "class=\"unchangeable selectionlist\""%>>
						<option value="">- do not use units -
					</select>
				</td>
			</tr>
			<tr>
				<th>Default unit</th>
				<td>
					<select name="unit_id" 
						<%=!readCurrentQuantity ? "disabled readonly class=\"disabled\"" : "class=\"selectionlist\""%>>
					</select>
				</td>
			</tr>
			<%
			if (annotationType != null)
			{
				%>
				<tr>
					<th class="subprompt"></th>
					<td>
						<div class="messagecontainer help">
						Changing the default unit triggers a conversion of existing annotation values
						to the new unit. This may result in loss of precision due to rounding or 
						truncation.
						</div>
					</td>
				</tr>
				<%
			}
			%>
			<tr class="dynamic">
				<th></th>
				<td>
					<table style="width: 100%;">
					<tr>
						<th>Use units</th>
						<td></td>
						<th>Do not use</th>
					</tr>
					<tr>
						<td style="width: 50%;">
							<select name="usableUnits" id="usableUnits" 
								class="auto-init"
								data-auto-init="link-container"
								data-initial-items="[<%=HTML.encodeTags(jsonUsableUnits.toJSONString()) %>]"
								data-remove-to="allUnits"
								size="10" multiple style="width: calc(100% - 10px);"
								title="If no unit is selected, all units can be used"
							>
							</select>
						</td>
						<td style="width: 20px; padding: 2px;">
							<base:buttongroup vertical="true">
								<base:button
									id="btnAddUsableUnits"
									image="move_left.png"
									subclass="square"
									tooltip="Enable the annotation type for the selected unit(s)" 
								/>
								<base:button 
									subclass="square auto-init"
									data-auto-init="remove-link"
									data-list-id="usableUnits"
									data-remove-to="allUnits"
									id="btnRemoveUsableUnits"
									image="move_right.png"
									tooltip="Disable the annotation type for the selected unit(s)" 
								/>
							</base:buttongroup>
						</td>
						<td style="width: 50%;">
							<select name="allUnits" id="allUnits" size="10" multiple style="width: calc(100% - 10px);">
							</select>
						</td>
					</tr>
					</table>
				</td>
			</table>
		</t:tab>

		<t:tab id="categories" title="Categories" 
			helpid="annotationtype.edit.categories">
			<table class="fullform input100">
			<tr class="dynamic">
				<th>Categories</th>
				<td>
					<div class="selectionlist">
						<table>
						<tr>
						<td>
							<select name="categories" id="categories" 
								class="auto-init"
								data-auto-init="link-container"
								data-initial-items="[<%=HTML.encodeTags(jsonCategories.toJSONString()) %>]"
								size="14" multiple>
							</select>
						</td>
						<td style="vertical-align: top;">
							<base:buttongroup vertical="true">
								<base:button
									subclass="leftaligned auto-init"
									data-auto-init="add-link"
									data-list-id="categories"
									data-item-type="ANNOTATIONTYPECATEGORY" 
									style="width: 14em;"
									title="Add&nbsp;categories&hellip;" 
									tooltip="Add categories to this annotation type"
									/>
								<base:button 
									subclass="leftaligned auto-init"
									data-auto-init="remove-link"
									data-list-id="categories"
									style="width: 14em;"
									title="Remove" 
									tooltip="Remove the selected categories from this annotation type"
								/>
							</base:buttongroup>
						</td>
						</tr>
						</table>
					</div>
				</td>
			</tr>
			</table>
		</t:tab>
		</t:tabcontrol>
		</form>
		
		<div class="legend">
			<base:icon image="required.png" />= required information<br>
			<base:icon image="unchangeable.png" />= can't be changed later
		</div>

		<base:buttongroup subclass="dialogbuttons">
			<base:button id="btnSave" title="Save" />
			<base:button id="close" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
