<%-- $Id: index.jsp 7802 2020-04-30 12:49:01Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Sample"
	import="net.sf.basedb.core.BioSource"
	import="net.sf.basedb.core.BioMaterialEvent"
	import="net.sf.basedb.core.BioPlateEventType"
	import="net.sf.basedb.core.BioWell"
	import="net.sf.basedb.core.ItemSubtype"
	import="net.sf.basedb.core.Extract"
	import="net.sf.basedb.core.Kit"
	import="net.sf.basedb.core.Protocol"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultIterator"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.MultiPermissions"
	import="net.sf.basedb.core.OwnedItem"
	import="net.sf.basedb.core.AnnotatedItem"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.ItemAlreadyExistsException"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.util.RemovableUtil"
	import="net.sf.basedb.util.ShareableUtil"
	import="net.sf.basedb.util.OwnableUtil"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.plugins.ParentBioMaterialLoader"
	import="net.sf.basedb.clients.web.plugins.BioMaterialEventSourceFormatter"
	import="net.sf.basedb.clients.web.plugins.ParentBioMaterialEventSourceLoader"
	import="net.sf.basedb.clients.web.plugins.ItemQueryLoader"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.util.formatter.WellCoordinateFormatter"
	import="net.sf.basedb.util.formatter.NameableFormatter"
	import="net.sf.basedb.util.formatter.ItemTypeFormatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"

	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.clients.web.extensions.edit.OnSaveAction"
	import="net.sf.basedb.clients.web.extensions.edit.OnSaveRenderer"
	import="net.sf.basedb.clients.web.extensions.list.ListColumnExportRenderer"
	import="net.sf.basedb.clients.web.extensions.list.ListColumnAction"
	import="net.sf.basedb.clients.web.extensions.list.ListColumnUtil"
	import="java.util.Enumeration"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.util.List"
	import="java.util.ArrayList"
	import="java.util.Collections"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%!
	private static final ItemContext defaultContext = Base.createDefaultContext("name", "name,itemSubtype,originalQuantity,remainingQuantity,extracts,description");
	private static final Item itemType = Item.SAMPLE;
	
	private static void registerExportUtils(ItemContext cc)
	{
		// Register formatters
		cc.setObject("export.formatter.bioWell.row", new WellCoordinateFormatter(true));
		cc.setObject("export.formatter.bioWell.column", new WellCoordinateFormatter(false));
		cc.setObject("export.formatter.&creationEvent.sources(bioMaterial.name)", new BioMaterialEventSourceFormatter());
		cc.setObject("export.formatter.&childCreationEvents(event.bioMaterial.name)", new NameableFormatter());
		cc.setObject("export.formatter.&children(name)", new NameableFormatter());
		cc.setObject("export.formatter.parentType", new ItemTypeFormatter());
		
		// Register dataloaders
		String sampleParameter = "sample";

		// Child extracts
		ItemQuery<Extract> extractQuery = Extract.getQuery();
		extractQuery.include(cc.getInclude());
		extractQuery.restrict(Restrictions.eq(Hql.property("parent"), Expressions.parameter(sampleParameter)));
		extractQuery.order(Orders.asc(Hql.property("name")));
		cc.setObject("export.dataloader.&children(name)", new ItemQueryLoader<Sample>(extractQuery, sampleParameter));

		// Child samples
		ItemQuery<Sample> childSamplesQuery = Sample.getQuery();
		childSamplesQuery.join(Hql.innerJoin("creationEvent", "ce"));
		childSamplesQuery.join(Hql.innerJoin("ce", "sources", "src"));
		childSamplesQuery.restrict(Restrictions.eq(Hql.property("src", "bioMaterial"), Expressions.parameter(sampleParameter)));
		childSamplesQuery.order(Orders.asc(Hql.property("name")));
		childSamplesQuery.include(cc.getInclude());
		cc.setObject("export.dataloader.&childCreationEvents(event.bioMaterial.name)", new ItemQueryLoader<Sample>(childSamplesQuery, sampleParameter));
		
		// Parent samples
		cc.setObject("export.dataloader.&creationEvent.sources(bioMaterial.name)", new ParentBioMaterialEventSourceLoader());
	}	
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final String cmd = request.getParameter("cmd");
final String root = request.getContextPath()+"/";
final String mode = request.getParameter("mode");
final String callback = request.getParameter("callback");
final String itemId = request.getParameter("item_id");
final String listPage = "list_samples.jsp?ID="+ID
	+(mode == null ? "" : "&mode="+mode)
	+(callback == null ? "" : "&callback="+callback)
	+(itemId == null ? "" : "&item_id="+itemId);
final String viewPage = "view_sample.jsp?ID="+ID;
final String editPage = "edit_sample.jsp?ID="+ID;

String forward = null;
String redirect = null;
String message = null;
DbControl dc = null;

try
{
	if (cmd == null || "List".equals(cmd))
	{
		// Display the list page without updatinging the current context
		Base.getAndSetCurrentContext(sc, itemType, null, defaultContext, true);
		redirect = listPage;
	}
	else if ("UpdateContext".equals(cmd))
	{
		// Display the list page after updating the current context from the request parameters
		Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		redirect = listPage;
	}
	else if ("LoadContext".equals(cmd))
	{
		// Display the list page after loading a saved context
		int contextId = Values.getInt(request.getParameter("context"));
		Base.loadContext(sc, contextId, defaultContext);
		redirect = listPage;
	}

	else if ("ViewItem".equals(cmd))
	{
		// Display the view page for a single item 
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		forward = viewPage;
	}
	else if ("EditItem".equals(cmd))
	{
		// Display the edit page for a single item (should be opened in a popup)
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		redirect = editPage;
	}
	else if ("NewItem".equals(cmd))
	{
		// Display the edit page for a new item (should be opened in a popup)
		if (!sc.hasPermission(Permission.CREATE, itemType))
		{
			throw new PermissionDeniedException(Permission.CREATE, itemType.toString());
		}
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		cc.setId(0);
		forward = editPage;
	}
	else if ("NewPooledItem".equals(cmd))
	{
		// Display the edit page for a new pooled item (should be opened in a popup)
		if (!sc.hasPermission(Permission.CREATE, itemType))
		{
			throw new PermissionDeniedException(Permission.CREATE, itemType.toString());
		}
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		cc.setId(0);
		forward = editPage+"&pooled="+true;
	}
	else if ("UpdateItem".equals(cmd))
	{
		// Update the properties on an item (will close the popup)
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, defaultContext);
		final int maxRecent = Base.getMaxRecent(sc);
		dc = sc.newDbControl();
		Sample sample = cc.getObject("item");
		if (sample == null)
		{
			sample = Sample.getNew(dc);
			message = "Sample created";
			dc.saveItem(sample);
		}
		else
		{
			dc.reattachItem(sample, false);
			dc.reattachItem(sample.getCreationEvent(), false);
			message = "Sample updated";
		}

		// Create extension context
		JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(Item.SAMPLE), sample);
		ExtensionsInvoker<OnSaveAction> invoker = EditUtil.useOnSaveExtensions(jspContext);
		try
		{
			sample.setName(Values.getStringOrNull(request.getParameter("name")));
			sample.setDescription(Values.getStringOrNull(request.getParameter("description")));
			sample.setExternalId(Values.getStringOrNull(request.getParameter("external_id")));
			sample.setOriginalQuantity(Values.getFloat(request.getParameter("original_quantity"), null));

			int subtypeId = Values.getInt(request.getParameter("subtype_id"), -1);
			ItemSubtype subtype = null;
			if (subtypeId >= 0) // < 0 = denied or unchanged
			{
				if (subtypeId > 0) subtype = ItemSubtype.getById(dc, subtypeId);
				sample.setItemSubtype(subtype);
				cc.setRecent(Item.ITEMSUBTYPE, subtype, maxRecent);
			}
			
			BioMaterialEvent creationEvent = sample.getCreationEvent();
			if (creationEvent.hasPermission(Permission.WRITE))
			{
				Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
				creationEvent.setEventDate(dateFormatter.parseString(Values.getStringOrNull(request.getParameter("event_date"))));
				int protocolId = Values.getInt(request.getParameter("protocol_id"), -1);
				if (protocolId >= 0) // < 0 = denied or unchanged
				{
					Protocol pt = protocolId == 0 ? null : Protocol.getById(dc, protocolId);
					creationEvent.setProtocol(pt);
					cc.setRecent(Item.PROTOCOL, pt, subtype, maxRecent);
				}
				int kitId = Values.getInt(request.getParameter("kit_id"), -1);
				if (kitId >= 0) // < 0 = denied or unchanged
				{
					Kit kit = kitId == 0 ? null : Kit.getById(dc, kitId);
					creationEvent.setKit(kit);
					cc.setRecent(Item.KIT, kit, subtype, maxRecent);
				}
			}
	
			int biowellId = Values.getInt(request.getParameter("biowell_id"), -1);
			if (biowellId >= 0) // < 0 = denied or unchanged
			{
				BioWell bw = biowellId == 0 ? null : BioWell.getById(dc, biowellId);
				if (bw != null && bw.getBioMaterial() != null)
				{
					throw new WebException("popup", "Biowell can not be used",
							"The biowell [{1}] on bioplate {2} is already connected to another biomaterial", 
							HTML.encodeTags(bw.getRow()+"," + bw.getColumn()), HTML.encodeTags(bw.getPlate().getName()));
				}
				sample.setBioWell(bw);
				cc.setRecent(Item.BIOPLATE, bw == null ? null : bw.getPlate(), subtype, maxRecent);
			}
	
			// Parents tab
			Item parentType = Item.valueOf(request.getParameter("parentType"));
			if (parentType == Item.BIOSOURCE)
			{
				int bioSourceId = Values.getInt(request.getParameter("biosource_id"), -1);
				if (bioSourceId >= 0) // < 0 = denied or unchanged
				{
					BioSource bs = bioSourceId == 0 ? null : BioSource.getById(dc, bioSourceId);
					creationEvent.setSource(bs);
					cc.setRecent(Item.BIOSOURCE, bs, maxRecent);
				}
			}
			else
			{
				if (sample.getParentType() != Item.SAMPLE)
				{
					creationEvent.clearSources();
				}
				String[] modifiedSamples = Values.getString(request.getParameter("+SAMPLE")).split(",");
				for (int i = 0; i < modifiedSamples.length; ++i)
				{
					int sId = Values.getInt(modifiedSamples[i], -1);
					if (sId != -1) 
					{
						Sample s = Sample.getById(dc, sId);
						creationEvent.addSource(s).setUsedQuantity(Values.getFloat(request.getParameter("SAMPLE."+sId), null));
					}
				}
				String[] removedSamples = Values.getString(request.getParameter("-SAMPLE")).split(",");
				for (int i = 0; i < removedSamples.length; ++i)
				{
					int sId = Values.getInt(removedSamples[i], -1);
					if (sId != -1) creationEvent.removeSource(Sample.getById(dc, sId));
				}
			}
	
			// Annotations tab
			Base.updateAnnotations(dc, sample, sample, request);
			
			// OnSave extensions
			invoker.render(OnSaveRenderer.ON_SAVE);
			dc.commit();
			invoker.render(OnSaveRenderer.ON_COMMIT);
		}
		catch (Exception ex)
		{
			invoker.render(OnSaveRenderer.onRollback(ex));
			throw ex;
		}
		finally
		{
			cc.removeObject("item");
		}
	}
	else if ("DeleteItem".equals(cmd))
	{
		// Delete a single item and then return to the view page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		RemovableUtil.setRemoved(dc, itemType, Collections.singleton(cc.getId()), true);
		dc.commit();
		redirect = viewPage;
	}
	else if ("DeleteItems".equals(cmd))
	{
		// Delete all selected items on the list page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		int numTotal = cc.getSelected().size();
		int numRemoved = RemovableUtil.setRemoved(dc, itemType, cc.getSelected(), true);
		dc.commit();
		if (numTotal != numRemoved)
		{
			message = (numRemoved == 0 ? "No" : "Only "+numRemoved+" of "+numTotal) + " items could be deleted, because you have no DELETE permission";
		}
		redirect = listPage;
	}
	else if ("RestoreItem".equals(cmd))
	{
		// Restore a single item and then return to the view page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		RemovableUtil.setRemoved(dc, itemType, Collections.singleton(cc.getId()), false);
		dc.commit();
		redirect = viewPage;
	}
	else if ("RestoreItems".equals(cmd))
	{
		// Restore all selected items on the list page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		int numTotal = cc.getSelected().size();
		int numRemoved = RemovableUtil.setRemoved(dc, itemType, cc.getSelected(), false);
		dc.commit();
		if (numTotal != numRemoved)
		{
			message = (numRemoved == 0 ? "No" : "Only "+numRemoved+" of "+numTotal) + " items could be restored, because you have no WRITE permission";
		}
		redirect = listPage;
	}
	else if ("ShareItem".equals(cmd))
	{
		// Display a popup window for sharing a single item
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		MultiPermissions permissions = ShareableUtil.getMultiPermissions(dc, itemType, Collections.singleton(cc.getId()));
		dc.close();
		cc.setObject("MultiPermissions", permissions);
		redirect = "../../common/share/share.jsp?ID="+ID+"&item_type="+itemType.name();
	}
	else if ("ShareItems".equals(cmd))
	{
		// Display a popup window for sharing all selected items on the list page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		MultiPermissions permissions = ShareableUtil.getMultiPermissions(dc, itemType, cc.getSelected());
		dc.close();
		cc.setObject("MultiPermissions", permissions);
		redirect = "../../common/share/share.jsp?ID="+ID+"&item_type="+itemType.name();
	}
	else if ("SetOwnerOfItem".equals(cmd))
	{
		// Change owner of items selected on a list page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		OwnedItem item = (OwnedItem)itemType.getById(dc, cc.getId());
		cc.setObject("OwnedItems", Collections.singleton(item));
		redirect = "../../common/ownership/ownership.jsp?ID="+ID+"&item_type="+itemType.name();
	}
	else if ("SetOwnerOfItems".equals(cmd))
	{
		// Change owner of items selected on a list page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		Set<OwnedItem> items = new HashSet<OwnedItem>();
		for (Integer id : cc.getSelected())
		{
			if (id != null) items.add((OwnedItem)itemType.getById(dc, id));
		}
		dc.close();
		cc.setObject("OwnedItems", items);
		redirect = "../../common/ownership/ownership.jsp?ID="+ID+"&item_type="+itemType.name();
	}
	else if ("InheritAnnotations".equals(cmd))
	{
		// Change owner of items selected on a list page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		Set<AnnotatedItem> items = new HashSet<AnnotatedItem>();
		for (Integer id : cc.getSelected())
		{
			if (id != null) items.add((AnnotatedItem)itemType.getById(dc, id));
		}
		dc.close();
		cc.setObject("AnnotatedItems", items);
		redirect = "../../common/annotations/batch_inherit.jsp?ID="+ID+"&item_type="+itemType.name();
	}
	else if ("ExportItems".equals(cmd))
	{
		// Run an export plugin in a list context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		final ItemQuery<Sample> query = Sample.getQuery();
		dc = sc.newDbControl();
		cc.configureQuery(dc, query, true);
		registerExportUtils(cc);
		cc.setQuery(query);
		JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.list(itemType), null);
		ExtensionsInvoker<ListColumnAction<Sample,?>> listInvoker = ListColumnUtil.useExtensions(jspContext);
		listInvoker.render(new ListColumnExportRenderer<Sample>(cc));
		dc.close();
		redirect = "../../common/export/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=LIST&title=Export+samples";
	}
	else if ("ExportItem".equals(cmd))
	{
		// Run an export plugin in single-item context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		registerExportUtils(cc);
		redirect = "../../common/export/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=ITEM&title=Export+sample";
	}
	else if ("ImportItems".equals(cmd))
	{
		// Run an import plugin in a list context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		final ItemQuery<Sample> query = Sample.getQuery();
		dc = sc.newDbControl();
		cc.configureQuery(dc, query, true);
		dc.close();
		cc.setQuery(query);
		redirect = "../../common/import/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=LIST&title=Import+sample";
	}
	else if ("ImportItem".equals(cmd))
	{
		// Run an import plugin in single-item context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		redirect = "../../common/import/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=ITEM&title=Import+sample";
	}
	else if ("RunListPlugin".equals(cmd))
	{
		// Run another plugin in a list context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		final ItemQuery<Sample> query = Sample.getQuery();
		dc = sc.newDbControl();
		cc.configureQuery(dc, query, true);
		dc.close();
		cc.setQuery(query);
		redirect = "../../common/plugin/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=LIST&main_type=OTHER&title=Run+plugin";
	}
	else if ("RunPlugin".equals(cmd))
	{
		// Run another plugin in single-item context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		redirect = "../../common/plugin/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=ITEM&main_type=OTHER&title=Run+plugin";
	}
	else if ("CreateItemList".equals(cmd))
	{
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		final ItemQuery<Sample> query = Sample.getQuery();
		dc = sc.newDbControl();
		cc.configureQuery(dc, query, true);
		dc.close();
		cc.setQuery(query);
		redirect = "../../views/itemlists/index.jsp?ID="+ID+"&cmd=NewItem&addItems=1&memberType=SAMPLE&formId=samples";
	}
	else if ("AddItemsToList".equals(cmd))
	{
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		final ItemQuery<Sample> query = Sample.getQuery();
		dc = sc.newDbControl();
		cc.configureQuery(dc, query, true);
		dc.close();
		cc.setQuery(query);
		redirect = "../../views/itemlists/add_items.jsp?ID="+ID+"&memberType=SAMPLE&formId=samples";
	}
	else if ("PlaceOnPlate".equals(cmd))
	{
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		final ItemQuery<Sample> query = Sample.getQuery();
		dc = sc.newDbControl();
		cc.configureQuery(dc, query, true);
		dc.close();
		cc.filterOnSelectedItems(query);
		sc.getCurrentContext(Item.BIOPLATEEVENT, BioPlateEventType.PLACE_ON_PLATE).setQuery(query);
		redirect = "../wizards/place_on_plate.jsp?ID="+ID+"&itemType=SAMPLE";
	}
	else
	{
		throw new WebException("popup", "Invalid command", "The command {1} is not recognised as a valid command.", cmd);
	}
}
finally
{
	if (dc != null) dc.close();
}

if (forward != null)
{
	sc.setSessionSetting("alert-message", message);
	pageContext.forward(forward);
}
else if (redirect != null)
{
	sc.setSessionSetting("alert-message", message);
	response.sendRedirect(redirect);
}
else if (message == null)
{
	response.sendRedirect(root + "common/close_popup.jsp?refresh_opener=1&wait=0");
}
else
{
	response.sendRedirect(root + "common/close_popup.jsp?refresh_opener=1&message="+HTML.urlEncode(message));
}
%>

