/* $Id $
	------------------------------------------------------------------
	Copyright (C) 2012 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
*/
'use strict';

var Impersonate = function()
{
	var impersonate = {};
	
	impersonate.initPage = function()
	{
		Buttons.addClickHandler('user_id.select', impersonate.selectUser);
		Events.addEventHandler('user_id', 'base-selected', Items.onItemSelected);

		// Login buttons
		Buttons.addClickHandler('btnLogin', impersonate.doLogin);
		Buttons.addClickHandler('close', App.closeWindow);
	}
	
	/**
		Open the 'select user' dialog.
	*/
	impersonate.selectUser = function()
	{
		var frm = document.forms['login'];
		var url = '&resetTemporary=1';
		if (frm.user_id.length > 0)
		{
			var id = Math.abs(parseInt(frm.user_id[0].value));				
			url += '&item_id='+id;
		}
		Dialogs.selectItem('USER', 'user_id', 0, url);
	}
	
	impersonate.doLogin = function(event)
	{
		var frm = document.forms['login'];

		// Check that a user has been selected
		if (!frm.user_id.value)
		{
			Forms.showNotification('user_id.select', 'Please select a user');
			return;
		}

		// Check 'remain on page' and 'redirect' options
		if (frm.remainOnPage.checked) 
		{
			frm.redirect.value = window.opener ? window.opener.location.href : '';
		}
		else
		{
			frm.useAutoStartPage.value = '1';
			frm.redirect.value = App.getRoot()+'my_base/index.jsp?ID='+App.getSessionId();
		}
		
		frm.submit();
	}
	
	return impersonate;
}();

Doc.onLoad(Impersonate.initPage);
