<%-- $Id: view_rawbioassay.jsp 7809 2020-05-19 11:35:05Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	buffer="500kb"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.AnnotationType"
	import="net.sf.basedb.core.AnnotationSet"
	import="net.sf.basedb.core.ExtendedProperties"
	import="net.sf.basedb.core.ExtendedProperty"
	import="net.sf.basedb.core.RawBioAssay"
	import="net.sf.basedb.core.Experiment"
	import="net.sf.basedb.core.RawDataType"
	import="net.sf.basedb.core.Protocol"
	import="net.sf.basedb.core.Software"
	import="net.sf.basedb.core.ArrayDesign"
	import="net.sf.basedb.core.Job"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.Group"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultIterator"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.MultiPermissions"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.ParameterInfo"
	import="net.sf.basedb.core.BasicItem"
	import="net.sf.basedb.core.Nameable"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.PluginConfiguration"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.ChangeHistoryUtil"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.renderer.PrefixSuffixRenderer"
	import="net.sf.basedb.clients.web.extensions.toolbar.ButtonAction" 
	import="net.sf.basedb.clients.web.extensions.toolbar.ToolbarUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.Collections"
	import="java.util.Date"
	import="java.util.Map"
	import="java.util.Set"
	import="java.util.List"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%!
	private static final Item itemType = Item.RAWBIOASSAY;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.ITEM);
%>
<%
final String root = request.getContextPath()+"/";
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String tab = Values.getString(request.getParameter("tab"), "properties");
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);

	String title = null;
	RawBioAssay rawBioAssay = RawBioAssay.getById(dc, itemId);
	RawDataType rawDataType = null;
	try
	{
		rawDataType = rawBioAssay.getRawDataType();
	}
	catch (Throwable t)
	{}
	
	Job job = null;
	boolean readJob = true;
	PluginDefinition plugin = null;
	boolean readPlugin = true;
	PluginConfiguration configuration = null;
	boolean readConfiguration = true;

	try
	{
		job = rawBioAssay.getJob();
	}
	catch (PermissionDeniedException ex)
	{
		readJob = false;
		readPlugin = false;
		readConfiguration = false;
	}
	if (job != null)
	{
		try
		{
			plugin = job.getPluginDefinition();
		}
		catch (PermissionDeniedException ex)
		{
			readPlugin = false;
		}
		try
		{
			configuration = job.getPluginConfiguration();
		}
		catch (PermissionDeniedException ex)
		{
			readConfiguration = false;
		}
	}

	
	final Formatter<Date> dateTimeFormatter = FormatterFactory.getDateTimeFormatter(sc);
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	final boolean writePermission = rawBioAssay.hasPermission(Permission.WRITE);
	final boolean deletePermission = rawBioAssay.hasPermission(Permission.DELETE);
	final boolean sharePermission = rawBioAssay.hasPermission(Permission.SET_PERMISSION);
	final boolean setOwnerPermission = rawBioAssay.hasPermission(Permission.SET_OWNER);
	final boolean isRemoved = rawBioAssay.isRemoved();
	final boolean isUsed = isRemoved && rawBioAssay.isUsed();
	final boolean deletePermanentlyPermission = deletePermission && !isUsed;
	final boolean isOwner = rawBioAssay.isOwner();
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, guiContext, rawBioAssay);
	ExtensionsInvoker<ButtonAction> invoker = ToolbarUtil.useExtensions(jspContext);
	%>
	<base:page title="<%=title%>" id="view-page">
	<base:head scripts="table.js,tabcontrol-2.js,~bioassays.js" styles="table.css,toolbar.css,headertabcontrol.css,path.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
	</base:head>
	<base:body>
		<p:path><p:pathelement
			title="Raw bioassays" href="<%="index.jsp?ID="+ID%>" 
			/><p:pathelement title="<%=HTML.encodeTags(rawBioAssay.getName())%>" 
			/></p:path>
		<div id="page-data" data-item-id="<%=itemId%>"></div>
		
		<t:tabcontrol 
			id="main" 
			subclass="content mastertabcontrol" 
			active="<%=tab%>">
		<t:tab id="properties" title="Properties">
			<div>
			<table class="fullform">
			<tr>
				<th class="itemstatus">
					<base:icon 
						image="shared.png" 
						visible="<%=rawBioAssay.isShared()%>"
						tooltip="This item is shared to other users, groups and/or projects"
					/>
					<base:icon 
						id="btnDeletePermanently"
						image="deleted.png"
						tooltip="This item has been flagged for deletion. Click to delete it now."
						enabled="<%=deletePermanentlyPermission %>"
						visible="<%=isRemoved%>" 
					/>
					<base:icon
						id="btnUsingItems"
						image="used.png" 
						tooltip="This item is used by other items and can't be permanently deleted. Show the items that are using this one"
						visible="<%=isRemoved && isUsed%>" />
				</th>
				<td style="padding: 0px;">
					<tbl:toolbar subclass="bottomborder bg-filled-50">
						<tbl:button 
							id="btnEdit"
							disabled="<%=!writePermission%>" 
							image="edit.png" 
							title="Edit&hellip;" 
							tooltip="<%=writePermission ? "Edit this raw bioassay" : "You do not have permission to edit this raw bioassay"%>" 
						/>
						<tbl:button 
							id="btnDelete"
							disabled="<%=!deletePermission%>" 
							image="delete.png" 
							title="Delete"
							visible="<%=!rawBioAssay.isRemoved()%>"
							tooltip="<%=deletePermission ? "Delete this raw bioassay" : "You do not have permission to delete this rawbioassay"%>" 
						/>
						<tbl:button 
							id="btnRestore"
							disabled="<%=!writePermission%>" 
							image="restore.png" 
							title="Restore"
							visible="<%=rawBioAssay.isRemoved()%>"
							tooltip="<%=writePermission ? "Restore this raw bioassay" : "You do not have permission to restore this rawbioassay"%>" 
						/>
						<tbl:button 
							id="btnShare"
							disabled="<%=!sharePermission%>"
							image="share.png"
							title="Share&hellip;" 
							tooltip="<%=sharePermission ? "Share this raw bioassay to other user, groups and projects" : "You do not have permission to share this raw bioassay"%>"
						/>
						<tbl:button 
							id="btnSetOwner"
							disabled="<%=!setOwnerPermission%>"
							image="take_ownership.png"
							title="Set owner&hellip;"
							tooltip="<%=setOwnerPermission ? "Change owner of this item" : "You do not have permission to change ownership of this item"%>"
						/>
						<tbl:button 
							id="btnImport"
							image="import.png" 
							data-plugin-type="IMPORT"  
							title="Import&hellip;" 
							tooltip="Import data" 
							visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
						/>
						<tbl:button 
							id="btnExport"
							image="export.png"
							data-plugin-type="EXPORT" 
							title="Export&hellip;" 
							tooltip="Export data" 
							visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
						/>
						<tbl:button 
							id="btnRunPlugin"
							image="runplugin.png"  
							data-plugin-type="OTHER" 
							title="Run plugin&hellip;" 
							tooltip="Run a plugin" 
							visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
						/>
						<ext:render extensions="<%=invoker%>" context="<%=jspContext%>" 
							wrapper="<%=new PrefixSuffixRenderer<ButtonAction>(jspContext, "<td>", "</td>") %>"/>
						<tbl:button
							image="help.png"
							subclass="auto-init"
							data-auto-init="help"
							data-help-id="rawbioassay.view.properties"
							title="Help&hellip;"
							tooltip="Get help about this page"
						/>
					</tbl:toolbar>
				</td>
			</tr>
		</table>
		<table style="width: 100%; height: 20em;" class="bottomborder">
		<tr>
			<td style="width: 50%; height: 100%;">
				<table class="fullform" >
				<tr>
					<th>Name</th>
					<td><%=HTML.encodeTags(rawBioAssay.getName())%></td>
				</tr>
				<tr>
					<th>Registered</th>
					<td><%=dateFormatter.format(rawBioAssay.getEntryDate())%></td>
				</tr>
				<tr>
					<th>Platform</th>
					<td><base:propertyvalue item="<%=rawBioAssay%>" property="platform" /></td>
				</tr>
				<tr>
					<th>Variant</th>
					<td><base:propertyvalue item="<%=rawBioAssay%>" property="variant" /></td>
				</tr>
				<tr>
					<th>Raw data type</th>
					<td><base:catch><%=HTML.encodeTags(rawBioAssay.getRawDataType().getName())%></base:catch></td>
				</tr>
				<tr>
					<th>Spots</th>
					<td><%=rawBioAssay.hasData() ? "yes (db: " + rawBioAssay.getNumDbSpots() + 
							"; file: " + rawBioAssay.getNumFileSpots() + ")" : "no"%></td>
				</tr>
				<tr>
					<th>Parent bioassay</th>
					<td><base:propertyvalue item="<%=rawBioAssay%>" property="parentBioAssay" /></td>
				</tr>
				<tr>
					<th>Parent extract</th>
					<td><base:propertyvalue item="<%=rawBioAssay%>" property="parentExtract" /></td>
				</tr>
				<tr>
					<th>Protocol</th>
					<td><base:propertyvalue item="<%=rawBioAssay%>" property="protocol" /></td>
				</tr>
				<tr>
					<th>Software</th>
					<td><base:propertyvalue item="<%=rawBioAssay%>" property="software" /></td>
				</tr>
				<tr>
					<th>Array design</th>
					<td><base:propertyvalue item="<%=rawBioAssay%>" property="arrayDesign" /></td>
				</tr>
				<tr>
					<th>Owner</th>
					<td><base:propertyvalue item="<%=rawBioAssay%>" property="owner" /></td>
				</tr>
				<tr class="dynamic">
					<th>Description</th>
					<td><%=HTML.niceFormat(rawBioAssay.getDescription())%></td>
				</tr>
				</table>
			</td>
			<td style="width: 50%; height: 100%;" class="leftborder">
				<table class="fullform">
				<tr>
					<th>Job</th>
					<td colspan="3"><%=Base.getLinkedName(ID, job, !readJob, true)%></td>
				</tr>
				<tr>
					<th>Plugin</th>
					<td colspan="3">
						<base:propertyvalue item="<%=rawBioAssay%>" property="job.pluginDefinition" nulltext="<i>External</i>" />
						<%=job != null && job.getPluginVersion() != null ? "(" + HTML.encodeTags(job.getPluginVersion()) + ")" : ""%>
					</td>
				</tr>
				<%
				if (configuration != null)
				{
					%>
					<tr>
						<th>Configuration / file format</th>
						<td colspan="3"><%=Base.getLinkedName(ID, configuration, !readConfiguration, true)%></td>
					</tr>
					<%
				}
				if (job != null)
				{
					%>
					<tr>
						<th>Type</th>
						<td><base:propertyvalue item="<%=job%>" property="itemSubtype" /></td>
					</tr>
					<tr>
						<th>Started</th>
						<td>
							<%=dateTimeFormatter.format(job.getStarted())%>
						</td>
					</tr>
					<tr>
						<th>Ended</th>
						<td>
							<%=dateTimeFormatter.format(job.getEnded())%>
						</td>
					</tr>
					<%
					if (job.getServer() != null)
					{
						%>
						<tr>
							<th>Server</th>
							<td>
								<%=HTML.encodeTags(job.getServerAndNode())%>
							</td>
						</tr>
						<%
					}
					for (String name : job.getParameterNames())
					{
						StringBuilder sb = new StringBuilder();
						String displayValue = "";
						String description = "";
						try
						{
							ParameterInfo pi = job.getParameterInfo(name);
							if (pi.getLabel() != null) name = HTML.encodeTags(pi.getLabel());
							description = HTML.encodeTags(pi.getDescription());
							List<?> values = pi.getValuesOrMask();
							int i = 0;
							for (Object value : values)
							{
								if (value != null)
								{
									if (i > 0) sb.append(", ");
									i++;
									if (value instanceof BasicItem)
									{
										BasicItem item = (BasicItem)value;
										String itemName = "";
										if (item instanceof File)
										{
											itemName = ((File)item).getPath().toString();
										}
										else if (item instanceof Nameable)
										{
											itemName = ((Nameable)item).getName();
										}
										else
										{
											itemName = item.toString();
										}
										sb.append(Base.getLink(ID, HTML.encodeTags(itemName), 
											item.getType(), item.getId(), item.hasPermission(Permission.WRITE)));
									}
									else if (value instanceof Date)
									{
										sb.append(dateFormatter.format((Date)value));
									}
									else
									{
										sb.append(HTML.encodeTags(value.toString()));
									}
								}
							}
							displayValue = sb.toString();
						}
						catch (Throwable ex)
						{
							displayValue = "<i>ERROR: "+ex.getMessage()+"</i>";
						}
						%>
						<tr>
							<th><span title="<%=description%>"><%=name%></span></th>
							<td>
								<%=displayValue%>
							</td>
						</tr>
						<%
					}
				}
				%>
				<tr class="dynamic">
					<th></th>
					<td colspan="3"></td>
				</tr>
				</table>
			</td>
			</tr>
			</table>
			</div>
			
			<jsp:include page="../../common/datafiles/list_files.jsp">
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="ID" value="<%=ID%>" />
			</jsp:include>
			
			<%
			Set<String> names = rawBioAssay.getHeaderNames();
			%>
			<base:section 
				id="headers"
				title="<%="Raw data headers (" + (names == null ? 0 : names.size()) + ")"%>"
				context="<%=cc%>"
				>
				<%
				if (names == null || names.size() == 0)
				{
					%>
					<div class="messagecontainer note">
					None.
					</div>
					<%
				}
				else
				{
					%>
					<table class="fullform fullborder">
					<%
					boolean needsTr = true;
					if (names != null)
					{
						for (String name : names)
						{
							%>
							<%=needsTr ? "<tr><th>" : "<th class=\"leftborder\">" %>
								<%=HTML.encodeTags(name)%></th>
								<td><%=HTML.encodeTags(rawBioAssay.getHeader(name))%></td>
							<%=needsTr ? "" : "</tr>"%>
							<%
							needsTr = !needsTr;
						}
						%>
						<%=needsTr ? "" : "<th class=\"leftborder\"></th><td></td></tr>"%>
						<%
					}
					%>
					</table>
					<%
				}
				%>
			</base:section>
			<%
			ItemQuery<Experiment> experimentQuery = rawBioAssay.getExperiments();
			experimentQuery.include(Include.ALL);
			experimentQuery.order(Orders.asc(Hql.property("name")));
			ItemResultList<Experiment> experiments = experimentQuery.list(dc);
			%>
			<base:section 
				id="experiments"
				title="<%="Experiments (" + experiments.size() + ")"%>"
				context="<%=cc%>"
				>
				<%
				if (experiments.size() == 0)
				{
					%>
					<div class="messagecontainer note">
					This raw bioassay isn't used in any experiments
					(or, you don't have permission to view them).
					</div>
					<%
				}
				else
				{
					%>
					<tbl:table
						id="tbl.experiments"
						columns="all"
						>
						<tbl:columndef 
							id="name"
							title="Name"
						/>
						<tbl:columndef 
							id="description"
							title="Description"
						/>
						<tbl:data>
							<tbl:headers>
								<tbl:headerrow>
									<tbl:columnheaders />
								</tbl:headerrow>
							</tbl:headers>
							<tbl:rows>
							<%
							for (Experiment item : experiments)
							{
								%>
								<tbl:row>
									<tbl:cell column="name"><base:icon 
										image="deleted.png" 
										tooltip="This item has been scheduled for deletion" 
										visible="<%=item.isRemoved()%>"
									/><%=Base.getLinkedName(ID, item, false, true)%></tbl:cell>
									<tbl:cell column="description"><%=HTML.encodeTags(item.getDescription())%></tbl:cell>
								</tbl:row>
								<%
							}
							%>
							</tbl:rows>
						</tbl:data>
					</tbl:table>
					<%
				}
				%>
			</base:section>

			<jsp:include page="../../common/anytoany/list_anytoany.jsp">
				<jsp:param name="ID" value="<%=ID%>" />
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="title" value="Other items related to this sample" />
			</jsp:include>
			<jsp:include page="../../common/itemlists/list_membership.jsp">
				<jsp:param name="ID" value="<%=ID%>" />
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="title" value="Item lists where this raw bioassay is a member" />
			</jsp:include>
			
			<jsp:include page="../../common/share/list_share.jsp">
				<jsp:param name="ID" value="<%=ID%>" />
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="title" value="Shared to" />
			</jsp:include>
			</t:tab>
			
			<t:tab id="annotations" title="Annotations &amp; parameters" 
				tooltip="View annotation values and protocol parameters" clazz="white">
				<jsp:include page="../../common/annotations/list_frameset.jsp">
					<jsp:param name="item_type" value="<%=itemType.name()%>" />
					<jsp:param name="item_id" value="<%=itemId%>" />
					<jsp:param name="ID" value="<%=ID%>" />
				</jsp:include>
			</t:tab>

			<t:tab id="rawdata" title="Raw data" visible="<%=rawBioAssay.getNumDbSpots() > 0%>" />
			<t:tab id="overview" title="Overview" 
				tooltip="Display a tree overview of related items">
				<jsp:include page="../../common/overview/overview.jsp">
					<jsp:param name="item_type" value="<%=itemType.name()%>" />
					<jsp:param name="item_id" value="<%=itemId%>" />
					<jsp:param name="ID" value="<%=ID%>" />
				</jsp:include>
			</t:tab>
			<t:tab id="history" title="History"
				tooltip="Displays a log with the history of this item"
				visible="<%=ChangeHistoryUtil.showChangeHistoryTab(sc)%>">
				<jsp:include page="../../common/history/frameset.jsp">
					<jsp:param name="item_type" value="<%=itemType.name()%>" />
					<jsp:param name="item_id" value="<%=itemId%>" />
					<jsp:param name="ID" value="<%=ID%>" />
				</jsp:include>
			</t:tab>
			</t:tabcontrol>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}

%>
