
package com.dawidweiss.ant.taskdefs;

import org.apache.tools.ant.*;
import org.apache.tools.ant.taskdefs.optional.*;
import java.io.*;


/**
 * A liaison class for Saxon XSLT processor.
 */
public final class SaxonLiaison extends TraXLiaison {

	  public SaxonLiaison() throws Exception {
	  	
	  }

    public void transform(File infile, File outfile) throws Exception {
			String previous = System.getProperty("javax.xml.transform.TransformerFactory");
			System.setProperty("javax.xml.transform.TransformerFactory", "com.icl.saxon.TransformerFactoryImpl");
			
			// change class loader?
			ClassLoader loader = Thread.currentThread().getContextClassLoader();
			try {
				Thread.currentThread().setContextClassLoader(this.getClass().getClassLoader());
				super.transform(infile, outfile);
			} finally {
				Thread.currentThread().setContextClassLoader(loader);
				if (previous != null) {
					System.setProperty("javax.xml.transform.TransformerFactory", previous);
				} else {
					// leave saxon as default.
				}
			}			
		}

}
